<template>
  <ContentWrapper>
    <div class="content-heading">
      <div>Relação de perfis
        <ol class="breadcrumb breadcrumb px-0 pb-0">
          <li class="breadcrumb-item active">
            <a href="/roles" @click.prevent="$router.push({path:'/roles'})">Perfis</a>
          </li>
        </ol>
      </div>
    </div>
    <div class="card">
      <div :class="'card-body'+(search.role ? ' whirl duo':'')">
        <Datatable
          v-if="!search.role"
          :options="dtOptions"
          class="table table-striped my-4 w-100"
          id="datatable"
        >
          <thead>
            <tr>
              <th data-priority="1">#</th>
              <th>Nome</th>
              <th>Permissões</th>
              <th>Ações</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="role in roles" :key="role.id">
              <td>{{role.id}}</td>
              <td>{{role.name}}</td>
              <td>
                <span
                  v-for="p of role.permissions"
                  :key="p.id"
                  class="badge badge-danger"
                >{{p.readable_name}}</span>
              </td>
              <td>
                <div class="btn-group">
                  <button class="btn btn-info btn-sm" type="button" @click="editRole(role)">
                    <em class="fas fa-user-edit" style="padding:5px"></em>
                  </button>
                  <button class="btn btn-danger btn-sm" type="button" @click="removeRole(role)">
                    <em class="fas fa-user-alt-slash" style="padding:5px"></em>
                  </button>
                </div>
              </td>
            </tr>
          </tbody>
        </Datatable>
      </div>
    </div>
  </ContentWrapper>
</template>
<script>
import Datatable from "@/components/Tables/Datatable";
import Multiselect from "vue-multiselect";
import swal from "sweetalert2";

import Role from "@/domain/role/Role";
import Permission from "@/domain/permission/Permission";

import RoleService from "@/domain/role/RoleService";
import PermissionService from "@/domain/permission/PermissionService";

import NotificationProvider from "@/provider/NotificationProvider";

export default {
  name: "role-list",
  components: {
    Datatable,
    Multiselect
  },
  created() {
    // buscando perfis
    this.search.role = true;
    this.roleService
      .list(999, 1)
      .then(response => {
        this.roles = response;
        this.search.role = false;
      })
      .catch(err => {
        console.log(JSON.stringify(err));
        this.notificationProvider.error(
          "Falha na comunicação",
          "Falha ao listar os perfis"
        );
        this.search.role = false;
      });
  },
  data() {
    return {
      process: {
        role: false,
        permission: false
      },
      search: {
        role: false,
        permission: false
      },
      roleService: new RoleService(),
      permissionService: new PermissionService(),
      roles: [],
      role: new Role(),
      permissions: [],
      permission: new Permission(),
      notificationProvider: new NotificationProvider(this.$notify),
      dtOptions: {
        paging: true, // Table pagination
        ordering: true, // Column ordering
        info: true, // Bottom left status text
        responsive: true,
        // Text translation options
        // Note the required keywords between underscores (e.g _MENU_)
        oLanguage: {
          sSearch: '<em class="fa fa-search"></em>',
          sLengthMenu: "_MENU_ registros por página",
          info: "Página _PAGE_ de _PAGES_",
          zeroRecords: "Nada encontrado",
          infoEmpty: "Nenhum registro",
          infoFiltered: "(Filtrado de _MAX_ itens)",
          oPaginate: {
            sNext: '<em class="fa fa-caret-right"></em>',
            sPrevious: '<em class="fa fa-caret-left"></em>'
          }
        },
        // Datatable key setup
        keys: false
      }
    };
  },
  methods: {
    // ROLES
    validateBeforeSubmitRole(scope) {
      this.$validator.validateAll(scope).then(result => {
        if (result) {
          this.process.role = true;
          if (this.role.id == 0) {
            // CADASTRANDO
            this.roleService
              .create(this.role)
              .then(response => {
                this.roles.push(response);
                this.role = new Role();
                this.process.role = false;
                this.modalRole = false;
                this.notificationProvider.success(
                  "REGISTRADO!",
                  this.role.name + " registrada com sucesso"
                );
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao registrar",
                  "Houve uma falha ao registrar o perfil"
                );
                this.process.role = false;
                this.modalRole = false;
              });
          } else {
            // EDITANDO
            this.roleService
              .update(this.role.id, this.role)
              .then(response => {
                for (var i = 0; i < this.roles.length; i++) {
                  if (this.roles[i].id == response.id) {
                    this.roles[i] = new Role(
                      response.id,
                      response.name,
                      response.permissions
                    );
                  }
                }
                this.notificationProvider.success(
                  "ATUALIZADO!",
                  this.role.name + " atualizada com sucesso"
                );
                this.role = new Role();
                this.process.role = false;
                this.modalRole = false;
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao atualizar",
                  "Houve uma falha ao atualizar o perfil"
                );
                this.process.role = false;
                this.modalRole = false;
              });
          }
        }
      });
    },
    removeRole(role) {
      swal({
        title: "Deletar " + role.name + "?",
        text: "Não será possível recuperar!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Sim, deletar!"
      }).then(result => {
        if (result.value) {
          this.roleService
            .delete(role.id)
            .then(response => {
              this.roles.forEach((el, index) => {
                if (role.id == el.id) {
                  this.roles.splice(index, 1);
                }
              });
              this.notificationProvider.success(
                "Deletado",
                "Perfil " + role.name + " deletado com sucesso!"
              );
            })
            .catch(err => {
              if (
                err.response &&
                err.response.data &&
                err.response.data.message &&
                err.response.data.message.indexOf(
                  "Integrity constraint violation"
                )
              ) {
                // erro de vinculo no banco
                this.notificationProvider.error(
                  "Não é possível remover",
                  "Existem registros vinculados a este registro"
                );
              } else {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao remover",
                  "Não foi possível remover este registro"
                );
              }
            });
        }
      });
    },
    editRole(role) {
      this.$router.push({
        path: "/role/" + role.id
      });
    }
  }
};
</script>